<?php
(defined('_VALID_MOS') OR defined('_JEXEC')) or die('Direct Access to this location is not allowed.');

/**
 *	Get list of tags for a given content
 */ 
function myGetTags($contentid) {
	$db = &cmsInstance('CMSDb');
	
	$query = "SELECT b.id,b.name FROM #__myblog_content_categories as a,#__myblog_categories as b WHERE b.id=a.category AND a.contentid='$contentid' ORDER BY b.name DESC";
	$db->query($query);
	$result = $db->get_object_list();
	
	return $result;
}

function myClearCache(){
	global $mainframe;

	$cms    =& cmsInstance('CMSCore');
	$cms->load('helper','directory');

	$list   = cmsGetFiles(MY_CACHE_PATH, '');

	foreach($list as $file){
	    // Only remove files that contains the naming convention for cache_
	    if(strstr($file, 'cache_')){
	        @unlink(MY_CACHE_PATH . '/' . $file);
		}
	}

	// For Joomla 1.0 we would still need to clear the cached files
	// located in $mosConfig_cachepath
	if(cmsVersion() == _CMS_JOOMLA10 || cmsVersion() == _CMS_MAMBO){
	    $list   = cmsGetFiles($mainframe->getCfg('cachepath'), '');
	    foreach($list as $file){
	        if(strstr($file, 'cache_'))
	            @unlink($mainframe->getCfg('cachepath') . '/' . $file);
		}
	}
}

/**
 * Get the status if user is allowed to post
 * Return: boolean
 **/
function myGetUserCanPost(){
	global $_MY_CONFIG;
	
	// Check posting permissions
	$posterIds  		= explode(',', $_MY_CONFIG->get('allowedPosters'));
	$postGroups 		= explode(',', $_MY_CONFIG->get('postGroup'));
	$extraPostGroups    = explode(',', $_MY_CONFIG->get('extraPostGroups'));
	$adminPostGroups    = explode(',', $_MY_CONFIG->get('adminPostGroup'));
	
	$cms =& cmsInstance('CMSCore');
	$cms->load('libraries', 'user');
	
	$userId		= $cms->user->id;
	$userType	= $cms->user->usertype;
		
	array_walk($postGroups, 'myTrim');
	array_walk($extraPostGroups, 'myTrim');
	array_walk($adminPostGroups, 'myTrim');

	# If user is not allowed to post
	if (!in_array($userType, $adminPostGroups)) {
		if (!in_array($userType, $extraPostGroups) and !in_array($userType, $postGroups) AND !(in_array($userId, $posterIds) OR in_array(myUserGetName($userId),$posterIds))) {
			return false;
		}
	}
	return true;
}

/**
 * Get the status if user is allowed to publish or unpublish
 * Return: boolean
 **/
function myGetUserCanPublish(){
	global $_MY_CONFIG, $my;

	$publishRights  = false;
	
	if(cmsVersion() == _CMS_JOOMLA10 || cmsVersion() == _CMS_MAMBO){
		$userId 	= $my->id;
		$userType	= $my->usertype;
	}elseif(cmsVersion() == _CMS_JOOMLA15){
		$user = & JFactory::getUser();
		$userId		= $user->id;
		$userType	= $user->usertype;
	}
	
	// Check publishing permissions
	$posterIds      	= explode(',', $_MY_CONFIG->get('allowedPublishers'));
	$publishers     	= explode(',', $_MY_CONFIG->get('publishControlGroup'));
	$extraPublishGroups = explode(',', $_MY_CONFIG->get('extraPublishGroups'));
	$adminPublishGroup	= explode(',', $_MY_CONFIG->get('adminPublishControlGroup'));

	array_walk($extraPublishGroups, 'myTrim');

	if (in_array($userType, $extraPublishGroups) or (in_array($userId, $posterIds) or in_array(myUserGetName($userId),$posterIds)) or in_array($userType, $publishers) or in_array($userType, $adminPublishGroup))
			return true;

	return false;
}

/**
 * Get the username of the specific userid
 **/

/**
 * Get the status of the azrul video mambot
 * Return: boolean
 **/
function myGetAzVideoBot(){
	$cms        =& cmsInstance('CMSCore');
	$db			=& cmsInstance('CMSDb');
	$azVideoId  = '';

	// Get the azrul video mambot's id
	$strSQL		= "SELECT `id` FROM #__mambots WHERE `element`='azvideobot' AND `folder`='content'";
	$db->query($strSQL);
	
	// Check if azrulvideomambot file even exists
	if(file_exists($cms->get_path('plugins') . '/content/azvideobot.php') && ($azVideoId = $db->get_value())){
		$strSQL = "SELECT `my_published` FROM #__myblog_mambots WHERE `mambot_id`='{$azVideoId}'";
		$db->query($strSQL);

		if($db->get_value() == "1"){
		    return true;
		} else{
		    return false;
		}
	} else {
	    return false;
	}
}

/**
 * Get the status of Jom Comment installation and integrated on the site.
 * Return: boolean
 **/
function myGetJomComment(){
	global $_MY_CONFIG;

	$cms        =& cmsInstance('CMSCore');
	
	if($_MY_CONFIG->get('useComment') && file_exists($cms->get_path('root') . '/administrator/components/com_jomcomment/config.jomcomment.php'))
	    return true;

	return false;
}

/**
 *	Get list of tags for a given user
 */ 
function myGetUserTags($uid) {
	global $sections;
	$db = &cmsInstance('CMSDb');
	$db->query("SELECT distinct(b.name) from #__content as c,#__myblog_content_categories as a,#__myblog_categories as b WHERE c.id=a.contentid and b.id=a.category and c.created_by=$uid and c.state='1' and c.sectionid in ($sections) and c.publish_up < now() ORDER BY b.name DESC");
	return $db->get_object_list();
}

/**
 *	Replace newlines with <br/> tags
 */ 
function my_strict_nl2br($text, $replac = " <br />") {
	return preg_replace("/\r\n|\n|\r/", $replac, $text);
}

/**
 *	Retrieve number of entries for a given user
 */ 
function myCountUserEntry($uid, $exclude_drafts = "") {
	global $_MY_CONFIG;

	$db 		= &cmsInstance('CMSDb');
	$sections   = $_MY_CONFIG->get('managedSections');

	$extra 		= "";
	
	if ($exclude_drafts == "1") {
		$extra = "and state='1' and publish_up < '" . date( 'Y-m-d H:i:s' ) . "'";
	}
	$db->query("SELECT COUNT(*) FROM #__content WHERE created_by='$uid' and sectionid IN ($sections) $extra");
	$result = $db->get_value();
	
	if ($result == "")
		return 0;
	
	return $result;
}

/**
 *	Retrieve number of comments for a given user
 */ 
function myCountUserComment($uid) {
	global $_MY_CONFIG;
	
	$db			= &cmsInstance('CMSDb');
	$sections   = $_MY_CONFIG->get('managedSections');
	
	$strSQL = "SELECT COUNT(*) FROM #__jomcomment AS a "
			. "INNER JOIN #__content AS b "
			. "WHERE b.id=a.contentid "
			. "AND a.option='com_myblog' "
			. "AND b.created_by='{$uid}'";
	$db->query($strSQL);
	
	$result = $db->get_value();

	if ($result == "")
		return 0;
	
	return $result;
}

/**
 *	Retrieve number of hits for a given user
 */ 
function myCountUserHits($uid) {
	global $_MY_CONFIG;

	$db 		= &cmsInstance('CMSDb');
	$sections   = $_MY_CONFIG->get('managedSections');
	
	$db->query("SELECT SUM(hits) FROM #__content WHERE created_by='$uid' and sectionid in ($sections) and state='1' and publish_up < NOW()");
	$result = $db->get_value();
	
	if ($result == "")
		return 0;
	
	return $result;
}

/**
 *	Retrieves a list of links to the unpublsihed entries for a user
 */ 
function myGetUserDraft($uid) {
	global $MYBLOG_LANG, $Itemid, $sectionid, $sections;
	
	$cms =& cmsInstance('CMSCore');
	$cms->load('helper', 'url');
	$db = & cmsInstance('CMSDb');
	$db->query("SELECT title,created,id FROM #__content WHERE created_by='$uid' AND state=0 and sectionid in ($sections) ORDER BY created");
	$result = $db->get_object_list();
	$drafts = "<em>";

	if ($result) {
		foreach ($result as $row) {
			$draftlink = cmsSefAmpReplace("index2.php?option=com_myblog&no_html=1&task=edit&id=$row->id&Itemid=$Itemid&admin=1");
			
			if ($drafts != "<em>")
				$drafts .= ", ";
			$drafts .= "<a class=\"draftLink\" href=\"$draftlink\">".$row->title."</a>";
		}
	} else {
		$drafts = $MYBLOG_LANG['_MB_NO_DRAFTS'];
	}
	
	$drafts .= "</em>";
	
	return $drafts;
}

/**
 *	Retrieves number of Jom comments for an article.
 */ 
function myCountJomcomment($article_Id, $com = "com_myblog") {
	$db = &cmsInstance('CMSDb');
	
	$db->query("SELECT COUNT(*) FROM #__jomcomment WHERE contentid='$article_Id' AND (`option`='$com' OR `option`='com_content') AND published='1'");
	$result = $db->get_value();
	
	return $result;
}

/**
 * Retrieves number of articles in a selected category.
 **/
function myGetCategoryCount($categoryId){
	$db =& cmsInstance('CMSDb');
	
	$strSQL = "SELECT COUNT(*) FROM #__content "
			. "WHERE `catid`='{$categoryId}' AND `state`='1'";

	$db->query($strSQL);
	return $db->get_value();
}

/**
 *	Get a list of categories for a content.
 */ 
function myCategoriesURLGet($contentid, $linkCats = true, $task="") {
	global $Itemid, $MYBLOG_LANG;
	
	$result = myGetTags($contentid);
	$catCount = count($result);
	$link = "";
	
	if ($task!="")
		$task = "&task=$task";
	
	if ($result) {
		$count = 0;
		
		foreach ($result as $row) {
			if ($link != "")
				$link .= ",&nbsp;";
			
			if ($linkCats) {
				if(cmsVersion() == _CMS_JOOMLA10 || cmsVersion() == _CMS_MAMBO){
					$url = ampReplace(sefRelToAbs("index.php?option=com_myblog$task&category=" . urlencode($row->name) . "&Itemid=$Itemid"));
				}elseif(cmsVersion() == _CMS_JOOMLA15){
					$url = JFilterOutput::ampReplace(JRoute::_("index.php?option=com_myblog$task&category=" . urlencode($row->name) . "&Itemid=$Itemid"));
				}
				
				$link .= "<a href=\"$url\">$row->name</a>";
			} else
				$link .= $row->name;
			$count++;
		}
	} else {
		$link .= "<i>".$MYBLOG_LANG['_MB_UNTAGGED']."</i>&nbsp;";
	}
	
	return $link;
}

/**
 *	Retrieves the comment link for a content
 */ 
function myCommentsURLGet($contentid, $addCommentCount = true, $task="") {
	global $Itemid, $MYBLOG_LANG;
	
	$link = "";
	
	if ($task!="")
		$task = "&task=$task";
	
	if ($addCommentCount) {
		//$commentlink = myGetPermalinkUrl($contentid, $task);
		$numcomment = intval(myCountJomcomment($contentid));
		//$link .= "<a href=\"$commentlink#comments\">".$MYBLOG_LANG['_MB_COMMENT']." ($numcomment)</a>";
	}
	
	return $MYBLOG_LANG['_MB_COMMENT']." ($numcomment) "; //$link;
}


/**
 *	Gets the author username/fullname   
 */ 
function myGetAuthorName($uid, $useFullName="") {
	$db = &cmsInstance('CMSDb');
	
	$select = "username";
	
	if ($useFullName == "1")
		$select = "name";
	
	$db->query("SELECT $select FROM #__users WHERE id='$uid'");
	$result = $db->get_value();
	
	return $result;
}

function myGetAuthorEmail($uid){
	$db = &cmsInstance('CMSDb');
	
	$db->query("SELECT `email` FROM #__users WHERE id='$uid'");
	$result = $db->get_value();
	
	return $result;
}

/** %UserName% 
 *	Gets the author's id
 */ 
function myGetAuthorId($name, $useFullName="") {
	$db = &cmsInstance('CMSDb');
	
	$name = urldecode($name);

	// If name is empty, just return 0 since some site somehow has username's ''
	if(!$name)
		return '0';

	// If display full name instead of username, need to check both fullname nad username,
	// just in case the blogger url param contains the username.
	if ($useFullName=="1")
	{
		$db->query("SELECT id FROM #__users WHERE name RLIKE '[[:<:]]$name"."[[:>:]]' or username RLIKE '[[:<:]]$name"."[[:>:]]' ");
		$result = $db->get_value();
		return ($result ? $result : "0");
	}
	
	// get exact username match
	$db->query("SELECT id FROM #__users WHERE username='$name'");
	$result = $db->get_value();
	
	// if not found, try get similar match
	if (!$result)
	{
		$db->query("SELECT id FROM #__users WHERE username RLIKE '[[:<:]]$name"."[[:>:]]'");
		$result = $db->get_value();
	}
	
	// if still not found, check name and see if contains username.
	if (!$result)
	{
		$db->query("SELECT id FROM #__users WHERE name RLIKE '[[:<:]]$name"."[[:>:]]'");
		$result = $db->get_value();
	}
	
	return ($result ? $result : "0");
}

/**
 *	Gets the author username/fullname 
 */ 
function myUserGetName($uid, $useFullName="") {
	$db = &cmsInstance('CMSDb');
	
	$uid = intval($uid);
	$select = "username";
	
	if ($useFullName == "1")
		$select = "name";
	
	$db->query("SELECT $select FROM #__users WHERE id=$uid");
	$username = $db->get_value();

	return $username;
}

function myEncodeString($contents) {
	$ascii = '';
	$strlen_var = strlen($contents);
	
	for ($c = 0; $c < $strlen_var; ++ $c) {
		$ord_var_c = ord($contents {
			$c });
		
		switch ($ord_var_c) {
			case 0x08 :
				$ascii .= '\b';
				break;
				
			case 0x09 :
				$ascii .= '\t';
				break;
				
			case 0x0A :
				$ascii .= '\n';
				break;
				
			case 0x0C :
				$ascii .= '\f';
				break;
				
			case 0x0D :
				$ascii .= '\r';
				break;
				
			default :
				$ascii .= $contents {
					$c };
		}
	}
	
	return $ascii;
}

// Return the complete & valid permalink-URL for the given content 
function myGetPermalinkUrl($uid, $task="") {
	$db = &cmsInstance('CMSDb');
	$cms = &cmsInstance('CMSCore');
	$cms->load('helper', 'url');
	
	$Itemid = myGetItemId();
	
	$db->query("SELECT permalink from #__myblog_permalinks WHERE contentid='$uid'");
	$link = $db->get_value();
	
	if (!$link OR empty($link)) {
		// The permalink might be empty. We need to delete it
		$db->query("DELETE FROM #__myblog_permalinks WHERE contentid='$uid'");
		
		$db->query("SELECT title from #__content WHERE id='$uid'");
		$title = $db->get_value();
		
		// remove unwatned chars from permalink
		$link = myTitleToLink(trim($title . ".html"));;
		$db->query("SELECT count(*) from #__myblog_permalinks WHERE permalink='$link' and contentid!='$uid'");
		$linkExists = $db->get_value();
		
		if ($linkExists) {
			$link = myTitleToLink(trim($title));
			
			$plink = "$link-$uid.html";
			$db->query("SELECT contentid from #__myblog_permalinks WHERE permalink='$plink' and contentid!='$uid'");
			$count = 0;
			
			while ($db->get_value()) {
				$count++;
				$plink = "$link-$uid-$count.html";
				$db->query("SELECT contentid from #__myblog_permalinks WHERE permalink='$plink' and contentid!='$uid'");
			}
			
			//$plink = urlencode($plink);
			$db->query("INSERT INTO #__myblog_permalinks SET permalink='$plink',contentid='$uid'");
		} else
		{
			$db->query("INSERT INTO #__myblog_permalinks SET permalink='$link',contentid='$uid' ");
		}		
	}
	
	$link = urlencode($link);
	
	if ($task!=""){
		$task = "&task=$task";
	}
	
	$url = "index.php?option=com_myblog&show={$link}{$task}&Itemid={$Itemid}";
	$sefUrl = cmsSefAmpReplace($url);

	// If $sefUrl does not start with http, we will have to make the url absolute,
	// this ensure that this link works with RSS Feed
// 	if(substr($sefUrl,0, 4) != 'http'){
// 		$sefUrl = $cms->get_path('live') .'/'. $sefUrl;
// 	}
	return $sefUrl;
}



// Return the complete & valid permalink-URL for the given content
function myGetPermalink($uid, $task="") {
	$db = &cmsInstance('CMSDb');
	$cms = &cmsInstance('CMSCore');

	$Itemid = myGetItemId();

	$db->query("SELECT permalink from #__myblog_permalinks WHERE contentid='$uid'");
	$link = $db->get_value();

	if (!$link OR empty($link)) {
		// The permalink might be empty. We need to delete it
		$db->query("DELETE FROM #__myblog_permalinks WHERE contentid='$uid'");

		$db->query("SELECT title from #__content WHERE id='$uid'");
		$title = $db->get_value();

		// remove unwatned chars from permalink
		$link = myTitleToLink(trim($title . ".html"));;
		$db->query("SELECT count(*) from #__myblog_permalinks WHERE permalink='$link' and contentid!='$uid'");
		$linkExists = $db->get_value();

		if ($linkExists) {
			$link = myTitleToLink(trim($title));

			$plink = "$link-$uid.html";
			$db->query("SELECT contentid from #__myblog_permalinks WHERE permalink='$plink' and contentid!='$uid'");
			$count = 0;

			while ($db->get_value()) {
				$count++;
				$plink = "$link-$uid-$count.html";
				$db->query("SELECT contentid from #__myblog_permalinks WHERE permalink='$plink' and contentid!='$uid'");
			}

			//$plink = urlencode($plink);
			$db->query("INSERT INTO #__myblog_permalinks SET permalink='$plink',contentid='$uid'");
   			return $plink;
		} else{
			$db->query("INSERT INTO #__myblog_permalinks SET permalink='$link',contentid='$uid' ");
            return $link;
		}
	}
	return $link;
}

/**
 * Get bookmarking links to be displayed when viewing blogs.
 **/
function myGetBookmarks(& $row){

	$link       = $row->permalink;
	$title      = $row->title;
	$text       = '';
	
	if(cmsVersion() == _CMS_JOOMLA10 || cmsVersion() == _CMS_MAMBO){
		$bookmarks  = array(
		                    'digg'  	=> ampReplace(_getBookmarkLink('digg', $link, $title)),
		                    'delicious' => ampReplace(_getBookmarkLink('delicious', $link, $title)),
		                    'spurl'     => ampReplace(_getBookmarkLink('spurl', $link, $title)),
		                    'reddit'    => ampReplace(_getBookmarkLink('reddit', $link, $title)),
		                    'furl'      => ampReplace(_getBookmarkLink('furl', $link, $title))
							);	
	}elseif(cmsVersion() == _CMS_JOOMLA15){
			$bookmarks  = array(
	                    'digg'  	=>  JFilterOutput::ampReplace(_getBookmarkLink('digg', $link, $title)),
	                    'delicious' =>  JFilterOutput::ampReplace(_getBookmarkLink('delicious', $link, $title)),
	                    'spurl'     =>  JFilterOutput::ampReplace(_getBookmarkLink('spurl', $link, $title)),
	                    'reddit'    =>  JFilterOutput::ampReplace(_getBookmarkLink('reddit', $link, $title)),
	                    'furl'      =>  JFilterOutput::ampReplace(_getBookmarkLink('furl', $link, $title))
						);
	}

	$row->text   .= "<div class=\"clear\">"
			. "<div>"
			. "<p>"
			. "<a href=\"" . $bookmarks['delicious'] . "\">del.icio.us</a>&#183;"
			. "<a href=\"" . $bookmarks['digg'] . "\">digg this</a>&#183;"
			. "<a href=\"" . $bookmarks['spurl'] . "\">spurl</a>&#183;"
	        . "<a href=\"" . $bookmarks['reddit'] . "\">reddit</a>&#183;"
	        . "<a href=\"" . $bookmarks['furl'] . "\">furl this</a>"
			. "</p>"
			. "</div>"
			. "</div>";

	return true;
}

function _getBookmarkLink($type, $link, $title)
{
	switch ($type)
	{
		case 'digg':
			return 'http://www.digg.com/submit?phase=2&url='.$link."&title=".$title;
		case 'delicious':
			return "javascript:void(window.open('http://del.icio.us/post?url='+encodeURIComponent('".$link."')+'&title='+encodeURIComponent('".str_replace("%26amp%3B", "%26", urlencode(addslashes($title)))."')+'&noui&jump=close&v=4','_blank','width=700,height=280,status=no,resizable=yes,scrollbars=auto'))";
		case 'spurl':
			return "javascript:d=document;void(window.open('http://www.spurl.net/spurl.php?v=3
			&title='+encodeURIComponent('".str_replace("%26amp%3Bamp%3B", "%26amp%3B", urlencode(htmlentities(addslashes($title))))."')+
			'&url='+escape('".$link."')+
			'&blocked='+encodeURIComponent(d.selection?d.selection.createRange().text:d.getSelection()),
			'_blank','width=450,height=550,status=no,resizable=yes,scrollbars=auto'))";
		case 'reddit':
			return  'http://reddit.com/submit?url='.$link.'&title='.$title;
		case'furl':
			return "javascript:(function(){
					var%20d=document;
					var%20c=window.getSelection?window.getSelection():'';
						var%20f=window.open('http://www.furl.net/storeIt.jsp?t='
						+encodeURIComponent('".str_replace(array("%26amp%3Bamp%3B", "%25") , array("%26amp%3B", "%2525"), htmlentities(addslashes($title)))
						."')+'&u=
						'+escape(escape('".$link."'))+'&c=
						'+encodeURIComponent(c),'myfurlwindow','width=475,height=540,left=75,top=20,resizable=yes');
						f.focus();return;
					})();";
	}
}

/**
 *	Displays images on image browser, resized while maintaining aspect ratio
 */ 
function displayAndResizeImages($img_array) {
	$uploadedImages = "";
	
	if ($img_array) {
		foreach ($img_array as $img) {
			if (!empty ($img)) {
				$img['filename'] = trim($img['filename']);
				$imageMaxSize = 80;
				$imageWidth = $img['width'];
				$imageHeight = $img['height'];
				
				if ($imageHeight > $imageMaxSize or $imageWidth > $imageMaxSize) {
					if ($imageHeight > $imageWidth) {
						$imageWidth = ($imageMaxSize / $imageHeight) * $imageWidth;
						$imageHeight = $imageMaxSize;
					} else {
						$imageHeight = ($imageMaxSize / $imageWidth) * $imageHeight;
						$imageWidth = $imageMaxSize;
					}
				}
				
				$basename = basename($img['filename']);
				
				
				$imgtag = "<img src='{$img['filename']}' hspace='4' vspace='4' align='left' alt='$basename' border='0' />";
				$imgtag = addslashes($imgtag);
				$onDblCick	 ="tinyMCE.execCommand('mceFocus',false, 'mce_editor_0');";
				$onDblCick	.="tinyMCE.execCommand('mceInsertContent',false, '$imgtag');";
				
				
				$uploadedImages .= "<div title=\"$basename\" class=\"imgContainerOut\" ondblclick=\"$onDblCick\">
					<span class=\"imgContainer\" onmouseover=\"this.className='imgContainerHover';\" onmouseout=\"this.className='imgContainer';\">
						<center>
							<img src=\"" . $img['filename'] . "\" width=\"$imageWidth\" height=\"$imageHeight\" />
						</center>
					</span>
					</div>";
			}
		}
	} else {
		$uploadedImages = " ";
	}
	
	return $uploadedImages;
}

/**
 *	Retrieves AJAX page navigation links
 */ 
function writeAjaxPageNav($comp, $func, $limit, $limitstart, $total, $loadingDivName, $loadingImgURL = "") {
	$txt = '';
	$displayed_pages = 10;
	$total_pages = $limit ? ceil($total / $limit) : 0;
	$this_page = $limit ? ceil(($limitstart +1) / $limit) : 1;
	$start_loop = (floor(($this_page -1) / $displayed_pages)) * $displayed_pages +1;
	
	if ($start_loop + $displayed_pages -1 < $total_pages) {
		$stop_loop = $start_loop + $displayed_pages -1;
	} else {
		$stop_loop = $total_pages;
	}
	
	$link = "javascript:loading('$loadingDivName','$loadingImgURL');jax.icall('$comp','" . $func . "','" . $limit . "',";
	
			
	$pnSpace = '';
	
	if (_PN_LT || _PN_RT)
		$pnSpace = "&nbsp;";
	
	if ($this_page > 1) {
		$page = ($this_page -2) * $limit;
		$txt .= '<a href="' . "$link '0');" . '" class="pagenav" ><img border=0 src="components/com_myblog/images/Backward_16x16.png" alt=""/>' . $pnSpace . _PN_START . '</a> ';
		$txt .= '<a href="' . "$link '$page');" . '" class="pagenav" ><img border=0 src="components/com_myblog/images/Play2_16x16.png" alt=""/>' . $pnSpace . _PN_PREVIOUS . '</a> ';
	} else {
	}
	
	for ($i = $start_loop; $i <= $stop_loop; $i++) {
		$page = ($i -1) * $limit;
		
		if ($i == $this_page) {
			$txt .= '<span class="pagenav">' . $i . '</span> ';
		} else {
			$txt .= '<a href="' . "$link '$page');" . '" class="pagenav"><strong>' . $i . '</strong></a> ';
		}
	}

	if ($this_page < $total_pages) {
		$page = $this_page * $limit;
		$end_page = ($total_pages -1) * $limit;
		$txt .= '<a href="' . "$link '$page');" . '" class="pagenav">' . _PN_NEXT . $pnSpace . '<img border=0 src="components/com_myblog/images/Play_16x16.png" alt=""/></a> ';
		$txt .= '<a href="' . "$link '$end_page');" . '" class="pagenav">' . _PN_END . $pnSpace . '<img border=0 src="components/com_myblog/images/Forward_16x16.png" alt=""/></a>';
	} else {
	}
	
	return $txt;
}

/**
 *	Gets the tag clouds given a query and number of cloud variations
 */ 
function myGetTagClouds($query, $clouds = 8) {
	$db = &cmsInstance('CMSDb');
	
	$db->query($query);
	$rows = $db->get_object_list();
	
	/* Test Data
	$rows = array();
	for($i = 0; $i < 10; $i++){
		$a = new StdClass();
		$a->name = $i.'-myblog';
		$a->frequency = 100*$i;
		$rows[] = $a;
	}
	*/
	
	if (!$rows)
		return "";
	
	$vals = array();
	foreach ($rows as $row) {
		$vals["{$row->frequency}"] = $row->frequency;
	}
	$maxFreq = max($vals);
	$minFreq = min($vals);
	
	$freqSize = $maxFreq - $minFreq;
	$freqSpacing	= $freqSize / $clouds;
	
	if($freqSpacing < 1){
		$freqSpacing = 1;
	}
	
	foreach ($rows as $row) {
		$tagClass = round($row->frequency / $freqSpacing);
		$result[] = array (
			'name' => $row->name,
			'cloud' => $tagClass
		);
	}
	
	usort($result, 'mySortTags');
	return $result;	

}

/**
 *	sort tags alphabetically 
 */ 
function mySortTags($a, $b) {
	return (strtoupper($a['name']) < strtoupper($b['name'])) ? -1 : 1;
}

/**
 *	Display page navigation, non ajaxed 
 */ 
function myWritePagesLinks($link, $total, $limitstart, $limit) {
	$total = (int) $total;
	$limitstart = (int) max($limitstart, 0);
	$limit = (int) max($limit, 0);
	$txt = '';
	$displayed_pages = 10;
	$total_pages = $limit ? ceil($total / $limit) : 0;
	$this_page = $limit ? ceil(($limitstart +1) / $limit) : 1;
	$start_loop = (floor(($this_page -1) / $displayed_pages)) * $displayed_pages +1;
	
	if ($start_loop + $displayed_pages -1 < $total_pages) {
		$stop_loop = $start_loop + $displayed_pages -1;
	} else {
		$stop_loop = $total_pages;
	}
	
	$link .= '&amp;limit=' . $limit;
	
	if (!defined('_PN_LT') || !defined('_PN_RT')) {
		DEFINE('_PN_LT', '&lt;');
		DEFINE('_PN_RT', '&gt;');
	}
	
	if (!defined('_PN_START'))
		define('_PN_START', 'Start');
	
	if (!defined('_PN_PREVIOUS'))
		define('_PN_PREVIOUS', 'Previous');
	
	if (!defined('_PN_END'))
		define('_PN_END', 'End');
	
	if (!defined('_PN_NEXT'))
		define('_PN_NEXT', 'Next');
	
	$pnSpace = '';
	
	if (_PN_LT || _PN_RT)
		$pnSpace = "&nbsp;";
	
	if ($this_page > 1) {
		$page = ($this_page -2) * $limit;
		$txt .= '<a href="' . sefRelToAbs("$link&amp;limitstart=0") . '" class="pagenav" title="' . _PN_START . '"><img border=0 src="components/com_myblog/images/Backward_16x16.png" alt=""/>' . $pnSpace . _PN_START . '</a> ';
		$txt .= '<a href="' . sefRelToAbs("$link&amp;limitstart=$page") . '" class="pagenav" title="' . _PN_PREVIOUS . '"><img border=0 src="components/com_myblog/images/Play2_16x16.png" alt=""/>' . $pnSpace . _PN_PREVIOUS . '</a> ';
	} else {
		$txt .= '';
		$txt .= '';
	}
	
	for ($i = $start_loop; $i <= $stop_loop; $i++) {
		$page = ($i -1) * $limit;

		if ($i == $this_page) {
			$txt .= '<span class="pagenav">' . $i . '</span> ';
		} else {
			$txt .= '<a href="' . sefRelToAbs($link . '&amp;limitstart=' . $page) . '" class="pagenav"><strong>' . $i . '</strong></a> ';
		}
	}
	
	if ($this_page < $total_pages) {
		$page = $this_page * $limit;
		$end_page = ($total_pages -1) * $limit;
		$txt .= '<a href="' . sefRelToAbs($link . '&amp;limitstart=' . $page) . ' " class="pagenav" title="' . _PN_NEXT . '">' . _PN_NEXT . $pnSpace . '<img border=0 src="components/com_myblog/images/Play_16x16.png" alt=""/></a> ';
		$txt .= '<a href="' . sefRelToAbs($link . '&amp;limitstart=' . $end_page) . ' " class="pagenav" title="' . _PN_END . '">' . _PN_END . $pnSpace . '<img border=0 src="components/com_myblog/images/Forward_16x16.png" alt=""/></a>';
	} else {
		$txt .= '';
		$txt .= '';
	}
	
	return $txt;
}

/**
 *	Retrieves avatar image url for a user
 */ 
function getAvatarImg($user_id) {
	global $_MY_CONFIG, $mainframe;
	
	$cms =& cmsInstance('CMSCore');
	$db = &cmsInstance('CMSDb');
	$db->query("SELECT email from #__users WHERE id='$user_id'");
	$email = $db->get_value();
	$grav_url = $cms->get_path('live') . "/components/com_myblog/images/guest.gif"; #get_url() doesnt work
	$avatarWidth = ($_MY_CONFIG->get('avatarWidth')) ? intval($_MY_CONFIG->get('avatarWidth')) : "";
	$avatarHeight = ($_MY_CONFIG->get('avatarHeight')) ? intval($_MY_CONFIG->get('avatarHeight')) : "";
	
	switch ($_MY_CONFIG->get('avatar')) {
		case "gravatar" :
			$avatarWidth = ($avatarWidth) ? $avatarWidth : "40";
			$grav_url = "http://www.gravatar.com/avatar.php?gravatar_id=" . md5($email) . "&default=" . urlencode($cms->get_path('live') . "/components/com_myblog/images/guest.gif") . "&size=$avatarWidth";
			break;
			
		case "fireboard":
			$fb_config_file = $cms->get_path('root') . "/administrator/components/com_fireboard/fireboard_config.php";
			if (file_exists($fb_config_file))
				include($fb_config_file);
			else
			    break;
				

			if ($fbConfig['avatar_src']=='fb')
			{
				// get the fireboard avatar path if fireboard config has avatar source set to fireboard
				$db->query("SELECT avatar from #__fb_users WHERE userid='$user_id'");
				$avatar_relative_path = $db->get_value();
				if ($avatar_relative_path)
				{
				    $fb_avatar  = '';
				    
				    #Check version
				    if($fbConfig['version'] == '1.0.2' || $fbConfig['version'] == '1.0.3'){
						$fb_avatar = "/components/com_fireboard/avatars/" . $avatar_relative_path;
					}
					else{
						// need to get the abs path since avatar path stored is relative to avatars directory for fireboard
						$fb_avatar = '/images/fbfiles/avatars/' . $avatar_relative_path;
					}
					$avatar_abs_path = $cms->get_path('root') . $fb_avatar;

					if (file_exists($avatar_abs_path))
							$grav_url   = $cms->get_path('live') . $fb_avatar;
				}
				break;
			} else if ($fbConfig['avatar_src']!="cb")
			{
				// this is for handling case where fireboard avatar source is clexus PM
				break;
			} 
				// if is CB, go to CB avatar
		case "cb" :
			$db->query("SELECT avatar FROM #__comprofiler WHERE user_id=" . $user_id . " AND avatarapproved=1");
			$result = $db->get_value();
			
			if ($result) {
				if (file_exists($cms->get_path('root') . "/components/com_comprofiler/images/" . $result))
					$grav_url = $cms->get_path('live') . "/components/com_comprofiler/images/" . $result;
				else
					if (file_exists($cms->get_path('root') . "/images/comprofiler/" . $result))
						$grav_url = $cms->get_path('live') . "/images/comprofiler/" . $result;
			}
			break;
		
		case "smf" :
			$smfPath = $_MY_CONFIG->get('smfPath');
			$smfPath = trim($smfPath);
			$smfPath = rtrim($smfPath, '/');
			if (!$smfPath or $smfPath == "" or !file_exists("$smfPath/Settings.php"))
				$smfPath = $cms->get_path() . "/forum";
			
			// check for SMF bridge, then use SMF bridge settings if SMF bridge installed
			if (!$smfPath or $smfPath == "" or !file_exists("$smfPath/Settings.php")) {
				$db->query("select id from #__components WHERE `option`='com_smf'");
				if ($db->get_value()) {
					$db->query("select value1 from #__smf_config WHERE variable='smf_path'");
					$smfPath = $db->get_value();
					$smfPath = str_replace("\\", "/", $smfPath);
					$smfPath = rtrim($smfPath, "/");
				}
			}
			
			// need to get the settings as SMF db / tables can be in different location
			if (file_exists("$smfPath/Settings.php")) {
				include("$smfPath/Settings.php");
				mysql_select_db($mainframe->getCfg('db'));
				$useremail = $email;
				mysql_select_db($db_name);
				
				// query for user avatar, id using email address
				$q = sprintf("SELECT avatar,ID_MEMBER FROM $db_prefix" . "members WHERE emailAddress='$useremail'");
				$result = mysql_query($q);
				
				if ($result)
				{
					$result_row = mysql_fetch_array($result);
					mysql_select_db($mainframe->getCfg('db'));
					
					if ($result_row) {
						$id_member = $result_row[1];
						
						if (trim($result_row[0]) != "") {
							if (substr($result_row[0], 0, 7) != "http://")
								$grav_url = $boardurl . "/avatars/$result_row[0]";
							else
								$grav_url = $result_row[0];
						} else {
							mysql_select_db($db_name);
							$q = sprintf("SELECT ID_ATTACH FROM $db_prefix" . "attachments WHERE ID_MEMBER='$id_member' and ID_MSG=0 and attachmentType=0");
							$result = mysql_query($q);
							
							if ($result)
							{
								$result_avatar = mysql_fetch_array($result);
								mysql_select_db($mainframe->getCfg('db'));
								if ($result_avatar[0])
									$grav_url = "$boardurl/index.php?action=dlattach;attach=" . $result_avatar[0] . ";type=avatar";
							}
						}
					}
				}
			}
			break;
		
		default :
			break;
	}
	
	return $grav_url;
}

/**
 *	Retrieves avatar link for a user
 */ 
function getAvatarLink($user_id) {
	global $_MY_CONFIG, $Itemid, $mainframe;
	
	$cms =& cmsInstance('CMSCore');
	$cms->load('helper', 'url');
	$db  = &cmsInstance('CMSDb');
	$db->query("SELECT email from #__users WHERE id='$user_id'");
	$email = $db->get_value();
	$link = "";
	
	switch ($_MY_CONFIG->get('avatar')) {
		case "fireboard":
			// Find the correct itemid
			$link = cmsSefAmpReplace("index.php?option=com_fireboard&Itemid=$Itemid&func=fbprofile&task=showprf&userid=$user_id");
			break;
			
		case "cb" :
			if ($user_id) {
				$link = cmsSefAmpReplace("index.php?option=com_comprofiler&task=userProfile&user=$user_id");
			}
			break;
		
		case "smf" :
			$smfPath = $_MY_CONFIG->get('smfPath');
			if (substr($smfPath, strlen($smfPath) - 1, 1) == "/")
				$smfPath = substr($smfPath, 0, strlen($smfPath) - 1);
			if (!$smfPath or $smfPath == "" or !file_exists("$smfPath/Settings.php")) {
				$db->query("select id from #__components WHERE `option`='com_smf'");
				if ($db->get_value()) {
					$db->query("select value1 from #__smf_config WHERE variable='smf_path'");
					$smfPath = $db->get_value();
					$smfPath = str_replace("\\", "/", $smfPath);
					$smfPath = rtrim($smfPath, "/");
				}
			}
			
			if (!$smfPath or $smfPath == "" or !file_exists("$smfPath/Settings.php"))
				$smfPath = $cms->get_path() . "/forum";
			
			if (file_exists("$smfPath/Settings.php")) {
				include("$smfPath/Settings.php");
				mysql_select_db($db_name);
				$useremail = $email;
				$q = sprintf("SELECT ID_MEMBER FROM $db_prefix" . "members WHERE emailAddress='%s'", mysql_real_escape_string($useremail));
				$result = mysql_query($q);
				$result_row = @mysql_fetch_array($result);
				mysql_select_db($mainframe->getCfg('db'));
				
				if ($result_row) {
					$db->query("select id from #__components WHERE `option`='com_smf'");
					$smfWrap = "";
					
					if ($db->get_value()) {
						$db->query("SELECT value1 from #__smf_config WHERE variable='wrapped'");
						$smfWrap = $db->get_value();
						
						if ($smfWrap == "true") {
							$smfWrap = "1";
						} else
							$smfWrap = "";
					}
					
					if ($smfWrap and $smfWrap != "") {
						$link = cmsSefAmpReplace("index.php?option=com_smf&action=profile&u=" . $result_row[0] . "&Itemid=$Itemid");
					} else
						$link = cmsSefAmpReplace($boardurl . "/index.php?action=profile&u=" . $result_row[0]);
				}
			}
			break;
		
		default :
			break;
	}
	
	return $link;
}

/**
 *	Gets the blog description for a user's blog
 */ 
function myGetAuthorDescription($userid) {
	$db = &cmsInstance('CMSDb');
	$db->query("SELECT description FROM #__myblog_user WHERE user_id='$userid'");
	$desc = $db->get_value();
	
	if (!$desc) {
		$desc = "<p>No desc available</p>";
	}
	
	return $desc; 
}

/**
 *	Gets RSS feed for a specific blog view
 */ 
function myGetBlogRSS($bloggerID = "", $tags = "", $keywords = "", $archive="") {
	global $MYBLOG_LANG, $_MY_CONFIG, $sections, $Itemid;
	
	$cms =& cmsInstance('CMSCore');
	$cms->load('helper', 'url');
	
	include_once ($cms->get_path() . '/includes/feedcreator.class.php');
	include_once ($cms->get_path() . '/includes/feedcreator.class.php');
	include_once ($cms->get_path() . '/components/com_myblog/libraries/datamanager.class.php');
	
	$db = &cmsInstance('CMSDb');
	
	if (!$_MY_CONFIG->get('useRSSFeed') or $_MY_CONFIG->get('useRSSFeed') == "0") {
		echo "<error>RSS feed not enabled</error>";
		return;
	}
	
	$blogger_username = "";
	
	if ($bloggerID != "") {
		$db->query("SELECT * from #__users WHERE id='$bloggerID'");
		$blogger = $db->get_object_list();
		
		if ($blogger) {
			$blogger = $blogger[0];
			$blogger_username = ($_MY_CONFIG->get('useFullName')=="1" ? $blogger->name :$blogger->username);
		} else
			$blogger_username = "";
	} else {
		$bloggerID = "";
	}
	
	if ($archive!=""){
		// Joomla 1.5 might convert the '-' to ':'
		$archive = urldecode($archive);
		$archive = str_replace(':', '-', $archive);
		$archive = date("Y-m-d 00:00:00", strtotime(str_replace("-", " ", "01 " . cmsGetVar('archive'))));
	}
	
	$rss = new RSSCreator20();
	
	$searchby = array('limit' => 20,
			'limitstart' => 0,
			'authorid' => $bloggerID,
			'category' => $tags,
			'search' => $keywords,
			'archive' => $archive,
			);

	$entries = mb_get_entries($searchby);
	$total = $searchby['total'];
	
	if(!class_exists('AzrulJXTemplate'))
	    include_once($cms->get_path('plugins') . '/system/pc_includes/template.php');
	    
	$tpl = new AzrulJXCachedTemplate(serialize($entries) . "_rss" . strval($bloggerID) . strval($tags) . strval($keywords) , strval($archive));
	
	if (!$tpl->is_cached()) 
	{
		$title = $MYBLOG_LANG['_MB_RSS_BLOG_ENTRIES'];
		
		if ($blogger_username and $blogger_username != "")
			$title .= " ".$MYBLOG_LANG['_MB_RSS_BLOG_FOR']." $blogger_username";
		
		if ($tags and $tags != "")
			$title .= " ".$MYBLOG_LANG['_MB_RSS_BLOG_TAGGED']." '$tags'";
		
		if ($keywords and $keywords != "")
			$title .= ", ".$MYBLOG_LANG['_MB_RSS_BLOG_KEYWORD']." '$keywords'";
		
		if ($archive and $archive != "")
		{
			$archive_display = date("F Y", strtotime($archive));
			$title .= " - $archive_display";
		}
		
		$db->query("SELECT description from #__myblog_user WHERE user_id='$bloggerID'");
		$description = $db->get_value();
		
		if (!$description or $description == "")
			$description = "$title";
		
		// remove readmore tag
		$description = str_replace('{readmore}', '', $description);	
			
		$rss->title = $title;
		$rss->description = $description;
		$rss->encoding = cmsGetISO();
		
		$rss->link = $cms->get_path('live');
		$rss->cssStyleSheet = NULL;
		
		if ($entries) {
			$count = 0;
			
			foreach ($entries as $row) {
				$count++;
				if ($count > 20)
					break;
				
				$item = new FeedItem();
				$item->title = $row->title != "" ? $row->title : "...";
				$item->title = myUnhtmlspecialchars($item->title);
				
				if ($row->fulltext == "")
					$itemDesc = $row->introtext != "" ? $row->introtext : "No description";
				else
					$itemDesc = $row->introtext . $row->fulltext;
					
				$desc_length_max = 500;
				$itemDesc = strip_tags($itemDesc, '<p> <br /> <br/> <br> <u> <i> <b> <img>');
				$actualDescLength = strlen($itemDesc);
				$itemDesc = substr($itemDesc, 0, $desc_length_max);
				$itemDesc = preg_replace("/\r\n|\n|\r/", "<br/>", $itemDesc);
				
				if ($actualDescLength > $desc_length_max)
					$itemDesc .= " [...]";
				
				$itemDesc = str_replace('{readmore}', '', $itemDesc);
				$item->description = $itemDesc;
				$item->link = html_entity_decode($row->permalink);
				$item->date = date('r', strtotime($row->created));
				$item->author	= myGetAuthorEmail($row->created_by);
				$categoriesList = myGetTags($row->id);
				$extraElements = array ();
				
				if ($categoriesList) {
					$categories = "";
					$indentString = " ";
					
					foreach ($categoriesList as $category) {
						$categoryName = $category->name;
						if ($categories != "")
							$categories .= "</category>\n$indentString<category>";
						$categories .= $categoryName;
					}
					
					$extraElements['category'] = $categories;
					$item->additionalElements = $extraElements;
				}
				
				$rss->addItem($item);
			}
		}
		
		$tpl->set('rss', $rss->createFeed());
	}
	
	$rsscontent = $tpl->fetch_cache(MY_TEMPLATE_PATH . "/admin/rss.tmpl.html");
	while (@ob_end_clean());
	echo trim(str_replace(array_keys($MYBLOG_LANG), array_values($MYBLOG_LANG), $rsscontent));
}

/**
 *	close all open HTML tags. works as HTML cleanup function
 */ 
function myCloseTags($html){
	#put all opened tags into an array
	preg_match_all("#<([a-z]+)( .*)?(?!/)>#iU",$html,$result);
	$openedtags=$result[1];
	
	#put all closed tags into an array
	preg_match_all("#</([a-z]+)>#iU",$html,$result);
	$closedtags=$result[1];
	$len_opened = count($openedtags);
	// all tags are closed
	if(count($closedtags) == $len_opened){
		return $html;
	}
	$openedtags = array_reverse($openedtags);
	// close tags
	for($i=0;$i < $len_opened;$i++) {
		if (!in_array($openedtags[$i],$closedtags) && $openedtags[$i] != 'img'){
			$html .= '</'.$openedtags[$i].'>';
		} else {
			unset($closedtags[array_search($openedtags[$i],$closedtags)]);
		}
	}
	return $html;
}

// Create a suitable link from a given title
function myTitleToLink($link)
{
    global $_MY_CONFIG;

    // Replace non-ASCII characters.
    $link = strtr($link,
 "\xe1\xc1\xe0\xc0\xe2\xc2\xe4\xc4\xe3\xc3\xe5\xc5".
 "\xaa\xe7\xc7\xe9\xc9\xe8\xc8\xea\xca\xeb\xcb\xed".
 "\xcd\xec\xcc\xee\xce\xef\xcf\xf1\xd1\xf3\xd3\xf2".
 "\xd2\xf4\xd4\xf6\xd6\xf5\xd5\x8\xd8\xba\xf0\xfa\xda".
 "\xf9\xd9\xfb\xdb\xfc\xdc\xfd\xdd\xff\xe6\xc6\xdf\xf8",
 "aAaAaAaAaAaAacCeEeEeEeEiIiIiIiInNo".
 "OoOoOoOoOoOoouUuUuUuUyYyaAso");
	$link = strtr($link, $_MY_CONFIG->replacements_array);
	
    // remove quotes, spaces, and other illegal characters
    $link = preg_replace(array('/\'/', '/[^a-zA-Z0-9\-.+]+/', '/(^_|_$)/'), array('', '-', ''), $link);

    return $link;
}

// Similar to trim, but with reference
function myTrim(&$string)
{
	$string = trim($string);
}

function i8n_date($date)
{
	global $MYBLOG_LANG;
	if($MYBLOG_LANG){
		foreach($MYBLOG_LANG as $key => $val)
		{
			$date = str_replace($key, $val, $date);
		}
	}
	
	return $date;
}

/**
 * Return the pdf link for specific content
 **/
function myGetPDFLink($contentId, $ItemId){
	$cms    =& cmsInstance('CMSCore');
	$cms->load('helper', 'url');

	if(cmsVersion() == _CMS_JOOMLA10 || cmsVersion() == _CMS_MAMBO){
	    $link   = cmsSefAmpReplace('index2.php?option=com_content&format=pdf&id=' . $contentId . '&Itemid=' . $ItemId);
	}else{
		$link	= cmsSefAmpReplace('index.php?view=article&id=' . $contentId . '&format=pdf');
	}
	$str    = '<a title="PDF" onClick="window.open(\'' . $link . '\',\'win2\',\'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no\'); return false;" ';
	$str    .= 'target="_blank" href="' . $link . '">';
	$str    .= '<img border="0" name="PDF" alt="PDF" src="' . $cms->get_path('live') . '/images/M_images/pdf_button.png"></a>';

	return $str;
}

/**
 * Return the Print link for specific content
 **/
function myGetPrintLink($contentId, $ItemId){
	$cms    =& cmsInstance('CMSCore');
	$cms->load('helper', 'url');
	
	if(cmsVersion() == _CMS_JOOMLA10 || cmsVersion() == _CMS_MAMBO){
		$link   = cmsSefAmpReplace('index2.php?option=com_content&task=view&id=' . $contentId . '&pop=1&page=0&Itemid=' . $ItemId);
	} else {
		$link   = cmsSefAmpReplace('index.php?index.php?view=article&id=' . $contentId . '&tmpl=component&print=1&task=printblog');
	}
	

	$str    = '<a title="Print" onClick="window.open(\'' . $link . '\',\'win2\',\'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no\'); return false;" ';
	$str    .= 'target="_blank" href="' . $link . '">';
	$str    .= '<img border="0" name="Print" alt="Print" src="' . $cms->get_path('live') . '/images/M_images/printButton.png"></a>';

	return $str;
}

/**
 * Return the Back link for specific content
 **/
function myGetBackLink(){
	global $MYBLOG_LANG;
	
	if(cmsVersion() == _CMS_JOOMLA10 || cmsVersion() == _CMS_MAMBO){
		$str    = '<div class="back_button"><a href="javascript:void(0);" onClick="javascript:history.go(-1);">' . _BACK . '</a></div>';
	}elseif(cmsVersion() == _CMS_JOOMLA15){
		$str    = '<div class="back_button"><a href="javascript:void(0);" onClick="javascript:history.go(-1);">' . JText::_( 'BACK' ) . '</a></div>';
	}
	return $str;
}

/**
 * Return valid Itemid for my blog links
 * If 'option' are currently on myblog, then use current ItemId 
 */  
function myGetItemId(){
	static $mbItemid = -1;
	
	if($mbItemid == -1){
		
		global $Itemid;
		$db = &cmsInstance('CMSDb');
		$mbItemid = $Itemid;
		$db->query("select id from #__menu where link LIKE '%option=com_myblog%' and published='1' AND `id`='$Itemid'");
		if(!$db->get_value()){
			// The current itemId is not myblog related, ignore it, and find a valid one
			// Menu type is 'component' for Joomla 1.0 and 'components' for Jooma 1.5
			$db->query("select id from #__menu where (type='component' or type='components') and link='index.php?option=com_myblog' and published='1'");
			$mbItemid = $db->get_value();
		}
	}

	return $mbItemid;
}

// Return the adminhome itemid
function myGetAdminItemId(){
	static $mbItemid = -1;
	
	if($mbItemid == -1){
		global $Itemid;
		$db = &cmsInstance('CMSDb');
		$mbItemid = $Itemid;
		$db->query("select id from #__menu where link LIKE '%option=com_myblog%' AND published='1' AND `id`='$Itemid' ");
		if(!$db->get_value()){
			// The current itemId is not myblog related, ignore it, and find a valid one
			$db->query("select id from #__menu where `link` LIKE '%option=com_myblog&task=adminhome%' AND published='1' AND `menutype`='usermenu' ");
			$mbItemid = $db->get_value();
		}
		
		// If no link from the preferred 'usermenu' Itemid, just use whatever myblog task=adminhome itemid we can find
		if(!$mbItemid){
			$db->query("select id from #__menu where `link` LIKE '%option=com_myblog&task=adminhome%' AND published='1'");
			$mbItemid = $db->get_value();
		}
		
		// If still cannot found, just search for a normal com_myblog link
		if(!$mbItemid){
			$db->query("select id from #__menu where `link` LIKE '%option=com_myblog%' AND published='1'");
			$mbItemid = $db->get_value();
		}
	}
	
	return $mbItemid;
}

/** Admin Stuffs **/

// Return array of links for the dashboard tabs
function myGetDashboardLinks(){
	global $_MY_CONFIG;

	$myitemid = myGetAdminItemId();

	$links   = array(
			cmsSefAmpReplace('index.php?option=com_myblog&task=adminhome&Itemid='.$myitemid),
			cmsSefAmpReplace('index.php?option=com_myblog&task=bloggerpref&Itemid='.$myitemid),
			cmsSefAmpReplace('index.php?option=com_myblog&task=bloggerstats&Itemid='.$myitemid)
	);	


 	// Check if integration with Jom comment is set.
	if($_MY_CONFIG->get('useComment')){
		$links[]	= cmsSefAmpReplace('index.php?option=com_myblog&task=showcomments&Itemid='.$myitemid);		
	}
	return $links;
}

function myGetDashboardLinksTitle(){
	global $_MY_CONFIG;

	include(MY_COM_PATH.'/language/'.$_MY_CONFIG->language);
	
	$captions   = array(
	                    $MYBLOG_LANG['TPL_MNU_MYBLOGS'],
	                    $MYBLOG_LANG['TPL_MNU_PREF'],
	                    $MYBLOG_LANG['TPL_MNU_STATS']
						);

 	// Check if integration with Jom comment is set.
	if($_MY_CONFIG->get('useComment')){
		$captions[] = $MYBLOG_LANG['TPL_MNU_COMMENTS'];
	}
	return $captions;
}

function myUnhtmlspecialchars( $string ){
	$string = str_replace ( '&amp;', '&', $string );
	$string = str_replace ( '&#039;', '\'', $string );
	$string = str_replace ( '&quot;', '"', $string );
	$string = str_replace ( '&lt;', '<', $string );
	$string = str_replace ( '&gt;', '>', $string );
	$string = str_replace ( '&uuml;', '', $string );
	$string = str_replace ( '&Uuml;', '', $string );
	$string = str_replace ( '&auml;', '', $string );
	$string = str_replace ( '&Auml;', '', $string );
	$string = str_replace ( '&ouml;', '', $string );
	$string = str_replace ( '&Ouml;', '', $string );    
	return $string;
}

function myGetDashboardScript(){
	ob_start();
	?>
<!-- css -->
<link href="<?php echo MY_COM_LIVE; ?>/css/style.css" rel="stylesheet" type="text/css" />
<link rel="stylesheet" href="<?php echo MY_COM_LIVE; ?>/css/ui.css" type="text/css" media="screen" />

<!--JavaScript-->
<script type="text/javascript" src="<?php echo MY_COM_LIVE; ?>/js/jq.js"></script> 

<script type="text/javascript"> 
var yPos;
if (window.innerHeight != null)
{
	yPos = window.innerHeight;
} else if (document.documentElement && document.documentElement.clientHeight)
{
	yPos = document.documentElement.clientHeight;
} else
{
	yPos = document.body.clientHeight;
}
function addLoadEvent(func) 
{ 
	var oldonload=window.onload;
	if (typeof window.onload !='function') 
	{ 
		window.onload=func;
	} else { 
		window.onload=function() 
		{ 
			oldonload();
			func();
		} 
	} 
} 
yPos=yPos-120;

function show_dashboard(src){
	<?php global $mainframe; ?>
	if(src)
		TB_show('MyBlog Composer','<?php echo $mainframe->getCfg('live_site'); ?>/'+ src +'&keepThis=true&TB_iframe=true&height='+yPos+'&width=820','');
	else
		TB_show('MyBlog Composer','<?php echo $mainframe->getCfg('live_site'); ?>/index2.php?option=com_myblog&no_html=1&task=write&Itemid=44&TB_iframe=true&height='+yPos+'&width=820','');
}

function create_iframe(src){
	var mainDiv 	= document.createElement("div");
	var containerDiv = document.createElement("div");
	var footerDiv 	 = document.createElement("div");
	
	var myWidth = 0, myHeight = 0;
	if( typeof( window.innerWidth ) == 'number' ) {
		//Non-IE
		myWidth = window.innerWidth;
		myHeight = window.innerHeight;
	} else if( document.documentElement && ( document.documentElement.clientWidth || document.documentElement.clientHeight ) ) {
		//IE 6+ in 'standards compliant mode'
		myWidth = document.documentElement.clientWidth;
		myHeight = document.documentElement.clientHeight;
	} else if( document.body && ( document.body.clientWidth || document.body.clientHeight ) ) {
		//IE 4 compatible
		myWidth = document.body.clientWidth;
		myHeight = document.body.clientHeight;
	}

	mainDiv.setAttribute("id", "myblog_composer_div");
	mainDiv.className = 'floatingdiv'; 
	containerDiv.innerHTML = '<div onclick="var el = document.getElementById(\'myblog_composer_div\');el.parentNode.removeChild(el);" style="float:right;margin-right:30px;margin-top:4px;cursor:pointer"><img src="<?php echo MY_COM_LIVE; ?>/images/dashboard_close.gif" /></div>';
	//containerDiv.innerHTML = '<span >dashboard</span>';
	
	footerDiv.innerHTML = '';
	footerDiv.className = 'floatingdiv-bottom';
	
	var iframe = document.createElement("iframe");
	iframe.setAttribute("src", src);
	iframe.setAttribute("id", "myblog_composer");
	iframe.setAttribute("scrolling", "no");
	iframe.setAttribute("frameBorder", "0");
	//iframe.setAttribute("style", "5");
	iframe.style.height = (yPos - 20 - 18) + 'px';
	iframe.style.width = '805px';
	iframe.style.marginTop = '15px';
	iframe.style.marginLeft = '20px';
	
	var leftPos = (myWidth - 837)/2;
	mainDiv.style.top = '60px';
	mainDiv.style.left = leftPos + 'px';
	mainDiv.style.height = yPos + 'px';
	mainDiv.style.width = '837px';
	
	containerDiv.style.top = '0px';
	containerDiv.style.left = '0px';
	containerDiv.style.height = '100%';
	containerDiv.style.width = '100%';
	
	containerDiv.appendChild(iframe);
	mainDiv.appendChild(containerDiv);
	mainDiv.appendChild(footerDiv);
	document.body.appendChild(mainDiv); 
}

</script>

<?php
	$content = ob_get_contents();
	ob_end_clean();
	return $content;
}

// Return list of all category for  the target section
function myGetCategoryList($sectionid){
	$categories = array();
	$cms =& cmsInstance('CMSCore');
	$cms->db->query("SELECT * FROM #__categories WHERE `section`='$sectionid' AND `published`='1' ORDER BY title");
	$categories = $cms->db->get_object_list();
	 
	return $categories;
}

// Custom callback function for tag sorting
// @param $a/$b is a myblog_category object
function myTagCmp($a, $b) {
	return strcmp($a->name, $b->name);
}

// Return the number of times the tag is used
function myCountTagUsed($tagid){
	$db = &cmsInstance('CMSDb');	
	$query = "SELECT COUNT(*) FROM #__myblog_content_categories WHERE `category`='$tagid'";
	$db->query($query);
	return $db->get_value();
}


// Return the html code for categories list, if content id is specified, 
// Set the checkbox as slected
function myGetTagsSelectHtml($contentid = 0){
	$db = &cmsInstance('CMSDb');	
	$query = "SELECT * FROM #__myblog_categories";
	$db->query($query);
	
	$result = $db->get_object_list();
	$currentTags = array();
	if($contentid){
		$ctags = myGetTags($contentid);
		if(!empty($ctags)){
			foreach($ctags as $ct)
				$currentTags[] = $ct->id;
		}
	}
	
	// Sort the tag alphabetically
	usort($result, 'myTagCmp');
	
	$html = '<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" ><tbody id="tagListings">';
	foreach($result as $row){
		$row->useCount = myCountTagUsed($row->id);
		
		$checked = in_array($row->id, $currentTags) ? 'checked="checked"' : '';
		$html .= '<tr>
                <td valign="middle"><input type="checkbox" name="tags[]" value="'. $row->id.'"  '.$checked.' /></td>
                <td width="100%" valign="middle"><label class="catitem" style="vertical-align:middle" title="'.$row->useCount.' blog entries">'. $row->name.'</label></td>
            </tr>';
    }
    $html .= '</tbody></table>';
	return $html;
}

// Return the html code for categories list, if content id is specified,
// Set the checkbox as slected
function myGetCategoryHtml($contentid = 0){
	global $_MY_CONFIG;
	
	$db			= &cmsInstance('CMSDb');
	$sections   = $_MY_CONFIG->get('postSection');

	// Get current category if the content has been set a category
	$strSQL     = "SELECT `catid` FROM #__content WHERE `id`='{$contentid}'";
	$db->query($strSQL);
	$selCat     = $db->get_value();

	// Load the list of categories on the site and dont show unpublished categories
	$strSQL = 'SELECT * FROM #__categories WHERE `section` IN (' . $sections . ') AND `published`=\'1\'';
	$db->query($strSQL);

	$categories = $db->get_object_list();

	$html = '<select id="catid" name="catid" size="1" class="text">';
	
	foreach($categories as $row){
		if(cmsVersion() == _CMS_JOOMLA10 || cmsVersion() == _CMS_MAMBO)
			$rowName	= $row->name;
		else
			$rowName	= $row->title;

	    if($selCat && $selCat == $row->id){
	        $html   .= '<option value="' . $row->id . '" selected="selected">' . $rowName . '</option>';
		}else{
		    $html   .= '<option value="' . $row->id . '">' . $rowName .'</option>';
		}
    }
    $html   .= '</select>';
    
	return $html;
}


function myGetJoomlaCategoryName($id){
	global $_MY_CONFIG;
	
	$db	 = &cmsInstance('CMSDb');
	
	$sql = "SELECT `name` FROM #__categories WHERE `id`='$id' ";
	return $db->get_value($sql);
}

function getPoweredByLink(){
	return '<div align="center" style="text-align:center; font-size:90%"><a href="http://www.azrul.com"></a></div>';
}


function myAddPathway($title, $link=''){
	global $mainframe;
	
	if(cmsVersion() == _CMS_JOOMLA15){
		$pathway	= &$mainframe->getPathway();
		$pathway->addItem($title, $link);
	} else {
		global $mainframe;
		$mainframe->appendPathWay($title);
	}
}

function myAddPageTitle($title){
	if(cmsVersion() == _CMS_JOOMLA15){
		$document =& JFactory::getDocument();
		$document->setTitle($title);
	} else {
		global $mainframe;
		$mainframe->setPageTitle($title);
	}
}
